#include <Wire.h>

#define SENSOR_SAMPLES    512

static float neai_buffer[SENSOR_SAMPLES] = {0.0};
static uint16_t neai_ptr = 0;

int const AMP_PIN = A0;       // Preamp output pin connected to A0

/* Prototypes ----------------------------------------------------------*/
void get_microphone_data(void);

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
}
void loop() {
  // put your main code here, to run repeatedly:
  get_microphone_data();
}


/* Functions declaration ----------------------------------------------------------*/
void get_microphone_data()
{
  static uint16_t temp = 0;
  if (analogRead(AMP_PIN) > 400){
    int sub = 0;
    while(neai_ptr < SENSOR_SAMPLES) {
      if (sub > 8){
        /* Fill neai buffer with new accel data */
        neai_buffer[neai_ptr] = analogRead(AMP_PIN);
        /* Increment neai pointer */
        neai_ptr++;
        sub = 0;
      }
      else{
        temp = analogRead(AMP_PIN);
      }
      sub ++;
    }
    for(uint16_t i = 0; i < SENSOR_SAMPLES; i++) {
       Serial.print(neai_buffer[i]);
       Serial.print(" ");
    }
    Serial.print("\n");
    /* Reset pointer */
    neai_ptr = 0;
  }
}
